//
// USBtbV[C^hCo
// Plug & Play pW[
//   
//
#include "wdm.h"
#include "stdarg.h"
#include "stdio.h"

#include "usbdi.h"
#include "usbdlib.h"
#include "msm60851.h"



/*++

Routine Description:

    IRP_MJ_PNP̃fBXpb`e[u[`łB
    ̃foCXɑPlug & PlayIRP܂

:
    DeviceObject - gFDOi@\foCXIuWFNgj̃|C^
    Irp          - I/ONGXgpPbgւ̃|C^

Return Value:

    NT status code

--*/
NTSTATUS FlashWr_ProcessPnPIrp(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp)
{
    PIO_STACK_LOCATION irpStack;
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus = STATUS_SUCCESS;
    NTSTATUS waitStatus;
    PDEVICE_OBJECT stackDeviceObject;
    KEVENT startDeviceEvent;


    //
    // ݂IRP̈ʒu擾܂B̓t@NVR[hƃp[^ǂɔzu
    // 邩Ƃ̂łB
    //
    irpStack = IoGetCurrentIrpStackLocation (Irp);

    //
    // foCXGNXeṼ|C^擾܂
    //

    deviceExtension = DeviceObject->DeviceExtension;
    stackDeviceObject = deviceExtension->TopOfStackDeviceObject;

    FLASHWR_KdPrint( DBGLVL_MEDIUM, ( "enter FlashWr_ProcessPnPIrp() IRP_MJ_PNP, minor %s\n",
        FLASHWR_StringForPnpMnFunc( irpStack->MinorFunction ) ));

	// FDÕfoCXGNXeV̖I/OiIRP̂߂̂́jZ܂
    FlashWr_IncrementIoCount(DeviceObject);

    FLASHWR_ASSERT( IRP_MJ_PNP == irpStack->MajorFunction );

    switch (irpStack->MinorFunction) {
    case IRP_MN_START_DEVICE:

	// oo}l[W̓\[X蓖ĂA邢̓foCXɂȂɂƁAIRP𑗂
	// ܂BfoCX͂̂ƐグA߂ăX^[g܂B邢̓foCX̓\[X
	// Đݒ~߂ƁAX^[g邩܂B

		// PDOIRP̂ҋ@Cxg܂B
        KeInitializeEvent(&startDeviceEvent, NotificationEvent, FALSE);
        IoCopyCurrentIrpStackLocationToNext(Irp);

        // [`Zbg܂BƁAPDOIRP̏ƂɃCxgnh
        // VOiԂɂ܂B
        IoSetCompletionRoutine(Irp,
                               FlashWr_IrpCompletionRoutine,
                               &startDeviceEvent,  // [`ɃReLXgƂăCxgʂ܂B
                               TRUE,    // ɃZbg
                               TRUE,    // G[ɃZbg
                               TRUE);   // LZɃZbg


        // PDOIRP܂B
        ntStatus = IoCallDriver(stackDeviceObject,
                                Irp);

        // PDOIĂȂA[`̃CxgZbĝ҂܂
        if (ntStatus == STATUS_PENDING) {

             // IRP̏I҂
            waitStatus = KeWaitForSingleObject(
                &startDeviceEvent,
                Suspended,
                KernelMode,
                FALSE,
                NULL);
        }

        // ŃX^[gAbv̏܂B
        // USBNCAghCóAURB(USB Request Packet)ZbgAbvANGXg
        // zXgRg[hCo(HCD)֑܂BURB\ׂ̂͂ĂUSBfoCXɑ邱Ƃ
        // łR}htH[}bg`Ă܂B
        // ŁAhCo̓foCXfXNv^i[AfoCXݒ肵܂B
        ntStatus = FlashWr_StartDevice(DeviceObject);
        Irp->IoStatus.Status = ntStatus;

		IoCompleteRequest (Irp,
						   IO_NO_INCREMENT
						   );

		FlashWr_DecrementIoCount(DeviceObject);
		return ntStatus;  // IRP_MN_START_DEVICE

    case IRP_MN_QUERY_STOP_DEVICE:

		// IRP_MN_QUERY_STOP_DEVICE/IRP_MN_STOP_DEVICEV[PX́A[U[IɃT[rX
		// ~vA邢PnPgCACRؒfvƂ悤ȁA
		// uVvVbg_E̊ԂɂN܂B
		// ̃V[PX́ANȂUSBR[h𔲂ƂAȊO̎vȂfoCX
		// ZbgsƂ悤ȁuȁvVbg_E̊Ԃɂ͎󂯎܂B

        // hCo͂IRPSTATUS_SUCCESSZbgƁAhCo͂ꎩg̃foCX̂
        // IRP_MN_STOP_DEVICE𐬌̂W悤ȁA鏈X^[gĂ͂܂B
        // HDD̂悤ȃ}XXg[WfoCXɒ~Ԃ̊ԁAhCo͂̃foCXւ̃ANZ
        // XvIRPێ܂ÂUSBfoCXł́u݃Xg[WvƂ̂͂܂
        // BAhCo̓X^[g邩~LZ܂ŁAh^n͋₵
        // Ăł傤B

		// foCXX^bÑhCoAfoCX\[X̍Đݒɂ~łȂƌ肵
		// ȂAhCoIRPʂ̃foCXX^bNɒʂƂv܂BAquery-stop
		// i~Ă悢ǂ̖₢킹jIRPsAPnP}l[W̓foCXX^bN
		// IRP_MN_STOP_DEVICE𑗂AhCo₢킹LZAfoCX~Ȃ
		// ehCoɒʒm܂B

        // foCXX^[gĂȂƂAIRP󂯎\܂iu[gfoCXƂj
        if (!deviceExtension->DeviceStarted) { // X^[gĂȂ炫Ƃ邱ƁB
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPnPIrp() IRP_MN_QUERY_STOP_DEVICE when device not started\n"));
            IoSkipCurrentIrpStackLocation (Irp);
            ntStatus = IoCallDriver (deviceExtension->TopOfStackDeviceObject, Irp);
            FlashWr_DecrementIoCount(DeviceObject);

            return ntStatus;
        }


        // ̓ǂݏIRPĂvs܂B
        if( deviceExtension->StagedPendingIrpCount ) {
            ntStatus = STATUS_UNSUCCESSFUL;
        }
        else { 
			// ۂʂ܂BĒ~NGXgtO𗧂Ă܂B
			// ЂƂ StopDeviceRequestedZbgꂽAVIOCTLǂݏpIRP
			// ʂ̃hCoփX^bN邱Ƃ͂܂BׂđɎs邱ƂɂȂ܂B
             deviceExtension->StopDeviceRequested = TRUE;
        }

        break; // end, case IRP_MN_QUERY_STOP_DEVICE

    case IRP_MN_CANCEL_STOP_DEVICE:

		// PnP}l[ẂAIRPhCoɃfoCX̃\[X̍Đݒ肪~ꂽƂʒm܂B
		// ́AIRP_MN_QUERY_STOP_DEVICEƂɂ󂯎܂B

		// foCXX^[gȂƂɁAIRP󂯎\܂B
        if (!deviceExtension->DeviceStarted) { // X^[gĂȂÃR[hʂƁB
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPnPIrp() IRP_MN_CANCEL_STOP_DEVICE when device not started\n"));
            IoSkipCurrentIrpStackLocation (Irp);
            ntStatus = IoCallDriver (deviceExtension->TopOfStackDeviceObject, Irp);
            FlashWr_DecrementIoCount(DeviceObject);
            return ntStatus;
        }

		// ̃tOZbgAVIOCTLI/OIRP͍̏ċ܂B
        deviceExtension->StopDeviceRequested = FALSE;
        break; // end, case IRP_MN_CANCEL_STOP_DEVICE

    case IRP_MN_STOP_DEVICE:

		// PnP}l[W͂IRPfoCX~邽߂ɂ܂BÃn[hEFA
		// \[XĐݒ\ł邱ƂɂȂ܂BPnP}l[W͂IRPOIRP_MN_QUERY_STOP_DEVICE
		// ĊƂɂ܂B


        // ׂĂI/ONGXgLZ܂ (ׂł͂Ȃǂ)
        FlashWr_CancelPendingIo( DeviceObject );

		// ݒnhNULL|C^ɂ悤SendConfigrationURB𑗂܂B́AݒN[YA
		// foCXݒԂɂ悤ɂ܂B
        ntStatus = FlashWr_StopDevice(DeviceObject);

        break; // end, case IRP_MN_STOP_DEVICE



    case IRP_MN_QUERY_REMOVE_DEVICE:

		// IRPɉāAhCo̓foCXVXe邱ƂȂ\ł邩ǂ
		// ܂B
		// hCoSɃfoCX邱Ƃ肷ƁAhCo͖I/ONGXg
		// AێĂp̓ǂݏNGXg𐮗AIrp->IoStatus.StatusSTATUS_SUCCESS
		// ɃZbg܂B@\hCoƃtB^[hCo͂ꂩfoCXX^bN̎̉ʂ̃hC
		// oIRPʂ܂B
		// w̃oXhCoIoCompleteRequestĂяo܂B

		// hCoIRPSTATUS_SUCCESSZbgȂAhCo̓foCX
		// IRP_MN_REMOVE_DEVICE𐬌Ɋ邱ƂW悤Ȃ鏈X^[gĂ͂܂B
		// foCXX^bÑhCo[ułȂƌ肵ȂAhCoquery-remove IRP
		// w̃foCXX^bNɒʂƂ͗v܂BAquery-remove IRPsȂA
		// oo}l[WIRP_MN_CANCEL_REMOVE_DEVICEfoCXX^bNɑA₢킹LZ
		// A[uȂȂfoCX̂ƂhCoɒʒm܂B

		// foCXX^[gȂƂɁAIRP󂯎\܂B
        if (!deviceExtension->DeviceStarted) { // X^[gĂȂÃR[hʂƁB
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPnPIrp() IRP_MN_QUERY_STOP_DEVICE when device not started\n"));
            IoSkipCurrentIrpStackLocation (Irp);
            ntStatus = IoCallDriver (deviceExtension->TopOfStackDeviceObject, Irp);
            FlashWr_DecrementIoCount(DeviceObject);

            return ntStatus;
        }

 		// x RemoveDeviceRequested ZbgꂽAVIOCTLA邢͓ǂݏIRPz̃hCo
 		// ɃX^bN܂BׂĂ̗v͑Ɏs܂B
       deviceExtension->RemoveDeviceRequested = TRUE;

        // ԂOɃhCoŖIONGXĝ҂܂B
		// ̃Cxg deviceExtension->PendingIoCount PɂȂƂɔ܂
        waitStatus = KeWaitForSingleObject(
                    &deviceExtension->NoPendingIoEvent,
                    Suspended,
                    KernelMode,
                    FALSE,
                    NULL);


        break; //

    case IRP_MN_CANCEL_REMOVE_DEVICE:

		// PnP}l[W͂IRPfoCX[uȂƂhCoɒʒm邽߂Ɏg܂B
		// IRP_MN_QUERY_REMOVE_DEVICE̐̂Ƃɂ܂B

        if (!deviceExtension->DeviceStarted) { // foCXX^[gĂȂ炱̃R[hs
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPnPIrp() IRP_MN_CANCEL_REMOVE_DEVICE when device not started\n"));
            IoSkipCurrentIrpStackLocation (Irp);
            ntStatus = IoCallDriver (deviceExtension->TopOfStackDeviceObject, Irp);
            FlashWr_DecrementIoCount(DeviceObject);
            return ntStatus;
        }

		// ̃tOZbgAVIOCTLIO IRPċ܂B
        deviceExtension->RemoveDeviceRequested = FALSE;

        break; //

	case IRP_MN_SURPRISE_REMOVAL:
        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPnPIrp() IRP_MN_SURPRISE_REMOVAL\n"));
		
		// ˔^̃foCXpiR[ḧȂǁjB
		// foCX͂łɊOĂ邽߁APnP}l[W̓[uIRPQuery-Remove
		// IRPȂɑ܂BfoCX͓˔̌ʂƂă[uIRP󂯎ƂɁA
		// ԂɂȂĂ\܂B

        // fBXpb`[`̊JnɃJEg킹܂i폜Ăł͒x(^^;
        FlashWr_DecrementIoCount(DeviceObject);

		//
        // x DeviceRemoved ZbgꂽAVIOCTLǂݏIRPʂ̃hCoɃX^bN
        // ܂BׂĂɎs܂B
		//
        deviceExtension->DeviceRemoved = TRUE;

		// ׂĂIONGXg̓LZ܂BfoCXȂ̂Aⓚp(^^)
		FlashWr_CancelPendingIo( DeviceObject ); 

		// ܂JĂpCv΁AUSBDURB_FUNCTION_ABORT_PIPEŌĂяo܂B
		// ̓pCvN[Y܂B[U[ʂČĂłAnopƂȂ܂B
		FlashWr_AbortPipes( DeviceObject );


		// ܘ_ʃhCô҂ȂĂ̂ǂAĂяoƃN[ibv
		// 邱Ƃ͂B
        IoCopyCurrentIrpStackLocationToNext(Irp);

        ntStatus = IoCallDriver(stackDeviceObject,
                                Irp);

		return ntStatus;

    case IRP_MN_REMOVE_DEVICE:

		// PnP}l[W͂IRPfoCX悤ɃhCoɎŵɎg܂B
		// uVvfoCXł́APnP}l[WIRP_MN_QUERY_REMOVE_DEVICEremoveIRP
		// ɑ܂B̏ꍇAremoveIRP͂Ƃɂ́AfoCX͉ԂɂȂĂ܂B
		// R[hȂǂ̓˔^̃foCXł́AfoCX͂łɍ폜ĂAPnP}l[W
		// IRP_MN_SURPRISE_REMOVAL𑗂Ȃ܂BfoCX͓˔̌ʂƂremoveIRP
		// 󂯎ƂɁAԂɂȂĂ\܂B

        // fBXpb`[`̍ŏɃJEg킹i폜Ăł͒x(^^;
        FlashWr_DecrementIoCount(DeviceObject);

		//
        // x DeviceRemoved ZbgꂽAVIOCTLǂݏIRP͉ʂ̃hCoɃX^bN
        // ܂BׂĂ͑Ɏs܂B
		//
        deviceExtension->DeviceRemoved = TRUE;

		// IONGXg̓LZ܂B_A₢킹͍ŏɂĂ̂ŕKvȂB
		FlashWr_CancelPendingIo( DeviceObject ); 

		// pCv܂JĂUSBDURB_FUNCTION_ABORT_PIPEŌĂт܂B̓pCvN[Y܂B
		// A[U[̃pCvʂĂȂɂĂAnopƂȂ܂B
		FlashWr_AbortPipes( DeviceObject );

		// ܘ_ʃhCô҂ȂĂ̂ǂAĂяoƃN[ibv
		// 邱Ƃ͂B
        IoCopyCurrentIrpStackLocationToNext(Irp);

        ntStatus = IoCallDriver(stackDeviceObject,
                                Irp);
		//
		// Ō̌ZifoCXGNXeV̖IO=0jdeviceExtension->RemoveEventZbgA
		// foCX̍폜܂B̎_łȂɂIOȂ΁Aw̌Zs܂B
        //
        FlashWr_DecrementIoCount(DeviceObject);


        // hCogŖIONGXg̉Î҂܂B
        KeWaitForSingleObject(
                    &deviceExtension->RemoveEvent,
                    Suspended,
                    KernelMode,
                    FALSE,
                    NULL);

        //
        // 쐬FDOƃN폜܂B
        //
        FlashWr_RemoveDevice(DeviceObject);


        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ProcessPnPIrp() Detaching from %08X\n",
                         deviceExtension->TopOfStackDeviceObject));

        IoDetachDevice(deviceExtension->TopOfStackDeviceObject);

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ProcessPnPIrp() Deleting %08X\n",
                         DeviceObject));

        IoDeleteDevice (DeviceObject);

        return ntStatus; // end, case IRP_MN_REMOVE_DEVICE


    default:
        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_ProcessPnPIrp() Minor PnP IOCTL not handled\n"));
    } /* case MinorFunction  */


    if (!NT_SUCCESS(ntStatus)) {

		// ȂɂʂƂȂ΁AIRPw̃hCoɓnsԂ܂
        Irp->IoStatus.Status = ntStatus;
		IoCompleteRequest (Irp,
						   IO_NO_INCREMENT
						   );

		FlashWr_DecrementIoCount(DeviceObject);

		FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_ProcessPnPIrp() Exit FlashWr_ProcessPnPIrp FAILURE %x\n", ntStatus));
		return ntStatus;
    }

    IoCopyCurrentIrpStackLocationToNext(Irp);

    //
    // ׂĂ PNP_POWER bZ[WPnPAddDeviceŗ^ꂽTopOfStackDeviceObjectɒʂ܂B
    //

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_ProcessPnPIrp() Passing PnP Irp down, status = %x\n", ntStatus));

    ntStatus = IoCallDriver(stackDeviceObject,
                            Irp);

    FlashWr_DecrementIoCount(DeviceObject);

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_ProcessPnPIrp() Exit FlashWr_ProcessPnPIrp %x\n", ntStatus));

    return ntStatus;
}

/*++

	̃[`͋@\foCXIuWFNg(FDO)̍쐬Ə̂߂ɌĂ΂܂B
	mVbNhCoł́ADriverEntry()ŏIĂ܂APlug&PlayfoCXłPnPCxg
	܂ő҂ƂɂȂ܂B

:

    DriverObject - FlashWr̃CX^X̃hCo[IuWFNg

    PhysicalDeviceObject - oXɂ쐬ꂽfoCXIuWFNg

Ԃl:

    ȂSTATUS_SUCCESSAȊOSTATUS_UNSUCCESSFULԂB

--*/
NTSTATUS
FlashWr_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    )
{
    NTSTATUS                ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT          deviceObject = NULL;
    PDEVICE_EXTENSION       deviceExtension;
    USBD_VERSION_INFORMATION versionInformation;
    ULONG i;


    
    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_PnPAddDevice()\n"));

    //
    // @\foCXIuWFNg(FDO)쐬܂B
    //

    ntStatus =
        FlashWr_CreateDeviceObject(DriverObject, PhysicalDeviceObject, &deviceObject);

    if (NT_SUCCESS(ntStatus)) {
        deviceExtension = deviceObject->DeviceExtension;

        deviceObject->Flags &= ~DO_DEVICE_INITIALIZING;

        //
        // _CNgI/O̓ǂݏ̓T|[gB
        //
        deviceObject->Flags |= DO_DIRECT_IO;


		// hCo[TXyhɃhCoIRP_MN_STOP_DEVICE󂯎ȂƂA
		// W[IRP_MN_START_DEVICE󂯎ȂƂɂ̃tOZbgB
		// ̓foCXJnĂяoGetDescriptors()ĂяoUSBX^bNɂ莸s
		// ̂ɕKvłB
        deviceObject->Flags |= DO_POWER_PAGABLE;

        // foCXGNXeV̏
        //
        // foCXIuWFNgZbg܂B
        //
        deviceExtension->PhysicalDeviceObject=PhysicalDeviceObject;

        //
        // foCXIuWFNg(PDO)ɃA^b`܂B
        //

        deviceExtension->TopOfStackDeviceObject =
            IoAttachDeviceToDeviceStack(deviceObject, PhysicalDeviceObject);

		// foCX̔\͏̃Rs[̃foCXGNXeV
		// DEVICE_CAPABILITIES\̂ɃZbg܂BԏdvȂ̂́AIRP_MJ_SET_POWERIRP
		// foCXp[Ԃ̂ǂɁAVXep[Ԃǂ}bvĂ邩w
		// ƂłB
        FlashWr_QueryCapabilities(PhysicalDeviceObject,
                                 &deviceExtension->DeviceCapabilities);


		// p[_Ẽxǂ邩肵܂BD3x
		// ԒႢX[vxƂȂ܂B
		// ׂD3ɃZbgꂽAp[_Eƃp[Abv͋܂B
        deviceExtension->PowerDownLevel = PowerDeviceUnspecified; // 񋖉ɏ
        for (i=PowerSystemSleeping1; i<= PowerSystemSleeping3; i++) {

			if ( deviceExtension->DeviceCapabilities.DeviceState[i] < PowerDeviceD3 )
				deviceExtension->PowerDownLevel = deviceExtension->DeviceCapabilities.DeviceState[i];
        }

#if DBG

        // WXg玩p[_ExI[o[Ch΁A
        // ( CurrentControlSet\Services\FlashWr\Parameters )
		// 0PWXgɃZbg܂B
        FlashWr_GetRegistryDword( FLASHWR_REGISTRY_PARAMETERS_PATH,
                                         L"PowerDownLevel",
                                         &(deviceExtension->PowerDownLevel) );



        //
        // foCX\͂̕\
        //

        FLASHWR_KdPrint( DBGLVL_MEDIUM,(" >>>>>> DeviceCaps\n"));
        FLASHWR_KdPrint( DBGLVL_MEDIUM,(" SystemWake = %s\n",
            FLASHWR_StringForSysState( deviceExtension->DeviceCapabilities.SystemWake ) ));
        FLASHWR_KdPrint( DBGLVL_MEDIUM,(" DeviceWake = %s\n",
            FLASHWR_StringForDevState( deviceExtension->DeviceCapabilities.DeviceWake) ));

        for (i=PowerSystemUnspecified; i< PowerSystemMaximum; i++) {

            FLASHWR_KdPrint( DBGLVL_MEDIUM,(" Device State Map: sysstate %s = devstate %s\n",
                 FLASHWR_StringForSysState( i ),
                 FLASHWR_StringForDevState( deviceExtension->DeviceCapabilities.DeviceState[i] ) ));
        }
        FLASHWR_KdPrint( DBGLVL_MEDIUM,(" <<<<<<<<DeviceCaps\n"));
#endif
		// hCoDeviceExtention̖̒I/O̐( extension->PendingIoCount )ێ܂
		// ̃JEg̍ŏ̉Z̓foCX̒ǉs܂B
		// ̂ƁÃJEg͊eX̐VIRPMŉZAeXIRPAʉ߂Ƃ
        // Z܂B

        // ܂́APւ̑JڂƂI/OȂƂ̂ӖAdeviceExtension->NoPendingIoEvent
        // VOiԂɂ킯łBIRP_MN_QUERY_REMOVE_DEVICȄɕKvłB

        // Oւ̑Jڂ̓Cxg(deviceExtension->RemoveEvent)VOiԂɂAfoCX[u
        // \ɂ܂BIRP_MN_REMOVE_DEVICȄɕKvłB
        FlashWr_IncrementIoCount(deviceObject);

    }

    USBD_GetUSBDIVersion(&versionInformation);



    if( NT_SUCCESS( ntStatus ) )  
    {
        NTSTATUS actStat;
        // IOۂɃNGXg܂ŃfoCXp[_E悤Ƃ܂B
        actStat = FlashWr_SelfSuspendOrActivate( deviceObject, TRUE );
    }


    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exit FlashWr_PnPAddDevice() (%x)\n", ntStatus));

    return ntStatus;
}


/*++

	IRP_MJ_PNP̃fBXpb`[`łFlashWr_ProcessPnPIrp()Ă΂܂B
    ^ꂽUSB̃foCX̃CX^X܂B
    FlashWr̂悤USBNCAghCo[́AzXgRg[hCo(HCD)
    NGXg𑗂URBiUSB Request Packet)ZbgAbv܂BURB\̂́ASĂ
    USBfoCXɑ邱Ƃ̂łR}h̃tH[}bg`Ă܂B
	ŁAFlashWr̓foCXfXNv^NGXgAێAfoCXݒ肵܂B
    
:

    DeviceObject - @\foCXIuWFNgւ̃|C^(FDO)

Ԃl:

    NTXe[^XR[h

--*/
NTSTATUS FlashWr_StartDevice(IN  PDEVICE_OBJECT DeviceObject)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PUSB_DEVICE_DESCRIPTOR deviceDescriptor = NULL;
    PURB urb;
    ULONG siz;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_StartDevice\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    urb = FLASHWR_ExAllocatePool(NonPagedPool,
                         sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST));

    FLASHWR_KdPrintCond( DBGLVL_HIGH,!urb, ("FlashWr_StartDevice() FAILED FLASHWR_ExAllocatePool() for URB\n"));

    if (urb) {

        siz = sizeof(USB_DEVICE_DESCRIPTOR);

        deviceDescriptor = FLASHWR_ExAllocatePool(NonPagedPool,
                                          siz);

        FLASHWR_KdPrintCond( DBGLVL_HIGH, !deviceDescriptor, ("FlashWr_StartDevice() FAILED FLASHWR_ExAllocatePool() for deviceDescriptor\n"));

        if (deviceDescriptor) {

            UsbBuildGetDescriptorRequest(urb,
                                         (USHORT) sizeof (struct _URB_CONTROL_DESCRIPTOR_REQUEST),
                                         USB_DEVICE_DESCRIPTOR_TYPE,
                                         0,
                                         0,
                                         deviceDescriptor,
                                         NULL,
                                         siz,
                                         NULL);


            ntStatus = FlashWr_CallUSBD(DeviceObject, urb);

            FLASHWR_KdPrintCond( DBGLVL_DEFAULT, !NT_SUCCESS(ntStatus), ("FlashWr_StartDevice() FAILED FlashWr_CallUSBD(DeviceObject, urb)\n"));

            if (NT_SUCCESS(ntStatus)) {
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("Device Descriptor = %x, len %x\n",
                                deviceDescriptor,
                                urb->UrbControlDescriptorRequest.TransferBufferLength));

                FLASHWR_KdPrint( DBGLVL_MEDIUM,("MSM608510 Device Descriptor:\n"));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("-------------------------\n"));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bLength %d\n", deviceDescriptor->bLength));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bDescriptorType 0x%x\n", deviceDescriptor->bDescriptorType));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bcdUSB 0x%x\n", deviceDescriptor->bcdUSB));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bDeviceClass 0x%x\n", deviceDescriptor->bDeviceClass));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bDeviceSubClass 0x%x\n", deviceDescriptor->bDeviceSubClass));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bDeviceProtocol 0x%x\n", deviceDescriptor->bDeviceProtocol));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bMaxPacketSize0 0x%x\n", deviceDescriptor->bMaxPacketSize0));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("idVendor 0x%x\n", deviceDescriptor->idVendor));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("idProduct 0x%x\n", deviceDescriptor->idProduct));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bcdDevice 0x%x\n", deviceDescriptor->bcdDevice));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("iManufacturer 0x%x\n", deviceDescriptor->iManufacturer));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("iProduct 0x%x\n", deviceDescriptor->iProduct));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("iSerialNumber 0x%x\n", deviceDescriptor->iSerialNumber));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("bNumConfigurations 0x%x\n", deviceDescriptor->bNumConfigurations));
            }
        } else {
			// ŃfoCXfXNv^̎擾ɎsB
            ntStatus = STATUS_INSUFFICIENT_RESOURCES;
        }

        if (NT_SUCCESS(ntStatus)) {
            deviceExtension->UsbDeviceDescriptor = deviceDescriptor;
        } else if (deviceDescriptor) {
            FLASHWR_ExFreePool(deviceDescriptor);
        }

        FLASHWR_ExFreePool(urb);

    } else {
		// URB̎擾Ɏs
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
    }

    if (NT_SUCCESS(ntStatus)) {
        ntStatus = FlashWr_ConfigureDevice(DeviceObject);

        FLASHWR_KdPrintCond( DBGLVL_MEDIUM,!NT_SUCCESS(ntStatus),("FlashWr_StartDevice FlashWr_ConfigureDevice() FAILURE (%x)\n", ntStatus));
    }


    if (NT_SUCCESS(ntStatus)) {
        deviceExtension->DeviceStarted = TRUE;
    }
    FLASHWR_KdPrint( DBGLVL_DEFAULT, ("exit FlashWr_StartDevice (%x)\n", ntStatus));

    return ntStatus;
}


/*++

Routine Description:

	foCX̃CX^XɊmۂꂽobt@ƃN[ibvAV{bNN
	邽߂FlashWr_ProcessPnPIrp()Ă΂܂B

:

    DeviceObject - @\foCXIuWFNg(FDO)ւ̃|C^
Ԃl:

    V{bNN̉ŏoNTXe[^XR[h

--*/ 
NTSTATUS FlashWr_RemoveDevice(IN  PDEVICE_OBJECT DeviceObject)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus = STATUS_SUCCESS;
    UNICODE_STRING deviceLinkUnicodeString;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_RemoveDevice\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    RtlInitUnicodeString (&deviceLinkUnicodeString,
                          deviceExtension->DeviceLinkNameBuffer);

    // GUIDx[X̃V{bNN̉
    ntStatus = IoSetDeviceInterfaceState(&deviceLinkUnicodeString, FALSE);
    FLASHWR_ASSERT( NT_SUCCESS( ntStatus ) );

    //
    // foCXfXNv^\̂̉
    //

    if (deviceExtension->UsbDeviceDescriptor) {
        FLASHWR_ExFreePool(deviceExtension->UsbDeviceDescriptor);
    }

    //
    // UsbInterface\̂̉
    //
    if (deviceExtension->UsbInterface) {
        FLASHWR_ExFreePool(deviceExtension->UsbInterface);
    }

	// USBRtBO[VfXNv^̉
    if (deviceExtension->UsbConfigurationDescriptor) {
        FLASHWR_ExFreePool(deviceExtension->UsbConfigurationDescriptor);
    }


    // IRPXg̉
    if ( deviceExtension->PendingIoIrps ) {
             FLASHWR_ExFreePool(deviceExtension->PendingIoIrps );

    }

	FLASHWR_ASSERT( gExAllocCount == 0 );
    FLASHWR_KdPrint( DBGLVL_HIGH,("exit FlashWr_RemoveDevice() gExAllocCount = dec %d\n", gExAllocCount ));

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exit FlashWr_RemoveDevice() status = 0x%x\n", ntStatus ));

    return ntStatus;
}



/*++
	^ꂽUSBFlashWriter̃CX^X~B
    {Iɍ̓foCXݒł邱Ƃ邾B

:

    DeviceObject - MSM60851̃CX^X̂߂̃foCXIuWFNgւ̃|C^

Ԃl:

    NTXe[^XR[h

--*/
NTSTATUS FlashWr_StopDevice(IN  PDEVICE_OBJECT DeviceObject)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PURB urb;
    ULONG siz;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_StopDevice\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    //
    // SelectConfigurationURBNULLݒnhƂĐݒ肷
    // ͐ݒAfoCX𖢐ݒԂɂB
    //

    siz = sizeof(struct _URB_SELECT_CONFIGURATION);

    urb = FLASHWR_ExAllocatePool(NonPagedPool,
                         siz);

    if (urb) {
        UsbBuildSelectConfigurationRequest(urb,
                                          (USHORT) siz,
                                          NULL);

        ntStatus = FlashWr_CallUSBD(DeviceObject, urb);

        FLASHWR_KdPrintCond( DBGLVL_DEFAULT,!NT_SUCCESS(ntStatus),("FlashWr_StopDevice() FAILURE Configuration Closed status = %x usb status = %x.\n", ntStatus, urb->UrbHeader.Status));

        FLASHWR_ExFreePool(urb);
    } else {
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
    }


    if (NT_SUCCESS(ntStatus)) {
        deviceExtension->DeviceStarted = FALSE;
    }

    deviceExtension->StopDeviceRequested = FALSE;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exit FlashWr_StopDevice() (%x)\n", ntStatus));

    return ntStatus;
}



/*++

Routine Description:

	ʓIȖړI̊[`ƂĎgBCxgVOiԂɂA
	̒ʂ̃hCo͂IRPIƂɃReLXgƂĒʂ܂B
	̃[`PnPƃp[}l[Wg̗Ŏg܂B

	Ƃ̃[`ȂĂCxg̓Zbg܂B͂ꂾŊ
	[`̌^ƂĒ`ĂȂ΂ȂȂłB

:

    DeviceObject - NXfoCXp̃foCXIuWFNg

    Irp - IRP

    Context - hCo`̃ReLXgB̏ꍇł̓CxgnĥƁB

Ԃl:

    ֐l͂̏̍Ō̃Xe[^XłB

--*/
NTSTATUS
FlashWr_IrpCompletionRoutine(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT event = Context;

    // ͂ꂽCxgnhZbg
    KeSetEvent(event,
               1,       // ҋ@Xbĥ߂ɗDIɉZ
               FALSE);  // ҋ@ɂ蒼ɂ̌Ăяo͑ɂł͂ȂƂƁB

    // ̃[`STATUS_MORE_PROCESSING_REQUIREDԂȂ΂ȂȂB
    // ȂȂA܂IRPIoFreeIrp()ĂłȂłB
    return STATUS_MORE_PROCESSING_REQUIRED;
}


/*++
	R}h̔siȂf[^̑MFUSoCg܂Łj
    
:
    DeviceObject - foCXIuWFNgւ̃|C^

Ԃl:
    NT Xe[^XR[h
--*/
NTSTATUS
FlashWr_RequestVendorCmd(
    IN PDEVICE_OBJECT DeviceObject,IN BOOLEAN isRead,IN UCHAR Request,IN USHORT Value,IN USHORT Index,IN void *buf,IN int size
   )
{
    NTSTATUS ntStatus;
    PURB urb;
    PVOID buff;

	if ((size>64) || (size<0)) return(STATUS_SUCCESS);
    urb = FLASHWR_ExAllocatePool(NonPagedPool, sizeof(struct _URB_CONTROL_VENDOR_OR_CLASS_REQUEST));

    if (urb) {
        buff=NULL;
        if (isRead) {
          buff = FLASHWR_ExAllocatePool(NonPagedPool, size);
          if (!buff) {
            FLASHWR_ExFreePool(urb);
            return(STATUS_INSUFFICIENT_RESOURCES);
          }
        }
        urb->UrbHeader.Function =  URB_FUNCTION_VENDOR_DEVICE;
        urb->UrbHeader.Length = sizeof(struct _URB_CONTROL_VENDOR_OR_CLASS_REQUEST);
        if (isRead) {
          urb->UrbControlVendorClassRequest.TransferFlags = USBD_TRANSFER_DIRECTION_IN;
          urb->UrbControlVendorClassRequest.TransferBuffer = buff;
        } else	{
           urb->UrbControlVendorClassRequest.TransferFlags = 0;
           urb->UrbControlVendorClassRequest.TransferBuffer = buf;
        }
        urb->UrbControlVendorClassRequest.TransferBufferLength = size;
        urb->UrbControlVendorClassRequest.TransferBufferMDL = NULL;
        urb->UrbControlVendorClassRequest.UrbLink = NULL;
        urb->UrbControlVendorClassRequest.RequestTypeReservedBits = 0;
        urb->UrbControlVendorClassRequest.Request = Request;
        urb->UrbControlVendorClassRequest.Value = Value;
        urb->UrbControlVendorClassRequest.Index = Index;

        ntStatus = FlashWr_CallUSBD(DeviceObject, urb);
		if (isRead) {
		  RtlCopyMemory(buf,buff,size);
          FLASHWR_ExFreePool(buff);
		}
        FLASHWR_ExFreePool(urb);

    } else {
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
    }

    return ntStatus;

}


