
#include "wdm.h"
#include "stdarg.h"
#include "stdio.h"

#include "usbdi.h"
#include "usbdlib.h"
#include "msm60851.h"


/*++

	́AgFDOIRP_MJ_POWER̃fBXpb`e[u֐łB
	̃foCXPDOɑPowerIRP܂B

	ׂĂPowerIRP̂߂ɊehCoPoStartNextPowerIrpĂяoAIRPw
	PDOɂ낢ȃhCoX^bNʂ߂PoCallDrivergȂ΂Ȃ܂B


:

    DeviceObject - foCXIuWFNg (FDO)

    Irp          - IONGXgpPbg

Ԃl:

    NTXe[^XR[h

--*/
NTSTATUS
FlashWr_ProcessPowerIrp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{

    PIO_STACK_LOCATION irpStack;
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    BOOLEAN fGoingToD0 = FALSE;
    POWER_STATE sysPowerState, desiredDevicePowerState;
    KEVENT event;

    FLASHWR_KdPrint( DBGLVL_MEDIUM,(" FlashWr_ProcessPowerIrp() IRP_MJ_POWER\n"));

    deviceExtension = (PDEVICE_EXTENSION) DeviceObject->DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    FlashWr_IncrementIoCount(DeviceObject);

    switch (irpStack->MinorFunction) {
    case IRP_MN_WAIT_WAKE:
        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Enter IRP_MN_WAIT_WAKE\n"));

		// hCóÃfoCXwakeCxgVOiԂɂ̂VXe҂ׂł邱
		// IRP_MN_WAIT_WAKE𑗂܂BCxg̐mȎނ̓foCXŗL̂̂łB
		// hCo͂IRPQ̗Rɂ著܂B
		// PjfoCXVXeNiwakejƂ
		// Qjp[Z[û߂ɃX[vԂɂꂽfoCXN߁BAǂȏԂłA
		//     ̃hCoŒʐM\ɂȂĂȂ΂ȂȂB
		// wakeCxgNƂAhCoIRPASTATUS_SUCCESSԂBfoCXC
		// xĝƂɃX[vԂɂ΁AhCo͂܂IRPOɃfoCXNȂ
		// ȂȂB
		// [`̒ŃhCo[PowerDeviceD0𑗂邽߂PoRequestPowerIrpĂяo܂Bfo
		// CXdIɂƂAhCo[IRP_MN_WAIT_WAKENGXg邱Ƃł܂B

        // deviceExtension->DeviceCapabilities.DeviceWake̓foCXwakeCxgVOiԂɂł
        // Ԓʂ̃foCX̃p[ (ŏ̃p[)w肵܂B
        deviceExtension->PowerDownLevel = deviceExtension->DeviceCapabilities.DeviceWake;


        if  ( ( PowerDeviceD0 == deviceExtension->CurrentDevicePowerState )  ||
              ( deviceExtension->DeviceCapabilities.DeviceWake > deviceExtension->CurrentDevicePowerState ) ) {
			// PowerD0ԁA邢͋N邱Ƃ̂łႢԂ̃foCX邩A邢SystemWake
			// ȉ̏ԂT|[gĂ΁ASTATUS_INVALID_DEVICE_STATEԂ܂B
			// foCXԂwakevŖԂɕς̂ł΁AIRP_MN_WAIT_WAKE͂
			// G[Ċ邱ƂɂȂ܂B
			//

			// hCoIRPsA̒ʂ̃hCoIRPʂƂȂɁAIRP
			// Ȃ΂ȂȂB
            ntStatus = STATUS_INVALID_DEVICE_STATE;
            Irp->IoStatus.Status = ntStatus;
            IoCompleteRequest (Irp,IO_NO_INCREMENT );
            FLASHWR_KdPrint( DBGLVL_HIGH, ( "Exit FlashWr_ProcessPowerIrp(), ntStatus STATUS_INVALID_DEVICE_STATE\n" ) );
            FlashWr_DecrementIoCount(DeviceObject);
            return ntStatus;
        }

        // NtOĂ܂B
        deviceExtension->EnabledForWakeup = TRUE;

		// PDOIRPsɃVOiԂɂA[`̂߂̃Cxg܂B
        KeInitializeEvent(&event, NotificationEvent, FALSE);

       // s܂Ȃ΁Aɉ̃nhŏ邽PDOɒʂ܂B
        IoCopyCurrentIrpStackLocationToNext(Irp);

		// [`Zbg܂BƁAPDOIRPsƂɃCxgVOiԂɂȂ܂B
        IoSetCompletionRoutine(Irp,
                               FlashWr_IrpCompletionRoutine,
                               &event,  // pass the event to the completion routine as the Context
                               TRUE,    // invoke on success
                               TRUE,    // invoke on error
                               TRUE);   // invoke on cancellation

        PoStartNextPowerIrp(Irp);
        ntStatus = PoCallDriver(deviceExtension->TopOfStackDeviceObject,
                                Irp);

         // PDO܂IĂȂ΁A[`CxgZbg܂őҋ@܂B
        if (ntStatus == STATUS_PENDING) {
             // IRP̊҂

            NTSTATUS waitStatus = KeWaitForSingleObject(
                &event,
                Suspended,
                KernelMode,
                FALSE,
                NULL);

            FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() done waiting for PDO to finish IRP_MN_WAIT_WAKE\n"));
        }

		// ŎۂɃfoCXNƂm点܂
		FlashWr_SelfSuspendOrActivate( DeviceObject, FALSE );

        // WakeupIRPtOZbg܂
        deviceExtension->EnabledForWakeup = FALSE;

        FlashWr_DecrementIoCount(DeviceObject);

        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Exit IRP_MN_WAIT_WAKE\n"));
        break;

    case IRP_MN_SET_POWER:
        {

		// VXep[|V[}l[ẂAVXep[ԂɃZbg邽߂ɁAIRP𑗂
		// ܂B܂AfoCXp[|V[}l[W͂IRPfoCXfoCXp[Ԃɂ
		// 邽߂ɑ܂B

        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Enter IRP_MN_SET_POWER\n"));

		// foCXNGXgꂽԂȂƂ߂ɁAIrp->IoStatus.StatusSTATUS_SUCCESS
		// Zbg܂BhCo[͂IRPs邱Ƃł܂B

        switch (irpStack->Parameters.Power.Type) {
            case SystemPowerState:

                // ͂ꂽVXep[Ԃ擾܂
                sysPowerState.SystemState = irpStack->Parameters.Power.State.SystemState;

                FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Set Power, type SystemPowerState = %s\n",
                    FLASHWR_StringForSysState( sysPowerState.SystemState ) ));

                // VXeԂɂ΁AɃfoCXƂɂD0ҋ@ԁA邢
                // system-to-deviceԂɃp[}bv悤ɂ܂
                if ( sysPowerState.SystemState ==  PowerSystemWorking) {
                    desiredDevicePowerState.DeviceState = PowerDeviceD0;

                     FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() PowerSystemWorking, will set D0, not use state map\n"));


                } else {
                     // IRP_MN_WAIT_WAKEԂȂ΁AvVXeԂɃZbg
                    if ( deviceExtension->EnabledForWakeup ) { // WAIT_WAKE IRP ?

						// ^ꂽVXeԂƓ̃foCXp[Ԃ܂BhCo
						// foCXGNXeViFlashWr_PnPAddDevice()ŏꂽ́j
						// ̒DEVICE_CAPABILITIES\̂擾܂B
                        desiredDevicePowerState.DeviceState =
                            deviceExtension->DeviceCapabilities.DeviceState[ sysPowerState.SystemState ];

                        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() IRP_MN_WAIT_WAKE pending, will use state map\n"));

                    } else {  
                        // ̂̂̑҂ȂAVXêꂪԂɂȂΏ܂
                        desiredDevicePowerState.DeviceState = PowerDeviceD3;

                        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Not EnabledForWakeup and the system's not in working state,\n  settting PowerDeviceD3 (off )\n"));
                    }
                }

                //
                // ]񂾃foCXԂ肵܂Błɂ̏Ԃɂ邩`FbNB
                //

                FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Set Power, desiredDevicePowerState = %s\n",
                    FLASHWR_StringForDevState( desiredDevicePowerState.DeviceState ) ));

                if (desiredDevicePowerState.DeviceState !=
                    deviceExtension->CurrentDevicePowerState) {

                    // FlashWr_IncrementIoCount(DeviceObject);

                    // PnP}l[W̐VPowerIRP̃NGXgɂ肱̏Ԃɓ̂ł͂Ȃ
                    // ̂ŃJE^ZKv͂ȂB
                    deviceExtension->PowerIrp = Irp;
                    ntStatus = PoRequestPowerIrp(deviceExtension->PhysicalDeviceObject,
                                               IRP_MN_SET_POWER,
                                               desiredDevicePowerState,
											   // [`IRPwPDOɓn
                                               FlashWr_PoRequestCompletion, 
                                               DeviceObject,
                                               NULL);

                } else {
                    // (^^)@PDOɒʂĂ
                    IoCopyCurrentIrpStackLocationToNext(Irp);
                    PoStartNextPowerIrp(Irp);
                    ntStatus = PoCallDriver(deviceExtension->TopOfStackDeviceObject,
                                            Irp);

                    FlashWr_DecrementIoCount(DeviceObject);
                    FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Exit IRP_MN_SET_POWER\n"));

                }
                break;

            case DevicePowerState:

                FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Set Power, type DevicePowerState = %s\n",
                    FLASHWR_StringForDevState( irpStack->Parameters.Power.State.DeviceState ) ));

                // D1,D2,D3̃NGXg(X[vA邢̓It)ł
				// deviceExtension->CurrentDevicePowerState𒼂DeviceStateɃZbg܂
				// ͊ɎX[vA邢̓ItԂɂ邱ƁAɏԂ؂ւ邱
				// l邽߂ɁȀԂ`FbNR[h܂.

                // DeviceState D0 (SI)ł́A[`ZbgA
                // deviceExtension->CurrentDevicePowerStateōXVȂ΂ȂȂƂ
                // fGoingToD0tOTRUEɂ܂B
                // SIɓd؂ւ悤ȏꍇACurrentDevicePowerStateXVȑOɁA
                // ̃vZXSƂhCo͊mMBAhCo
                // OɎs邩A󂯓IO͂ȂB

                fGoingToD0 = FlashWr_SetDevicePowerState(DeviceObject,
                                                      irpStack->Parameters.Power.State.DeviceState
                                                      ); // TRUEȂD0ԂB

                IoCopyCurrentIrpStackLocationToNext(Irp);

                if (fGoingToD0) {
                    FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Set PowerIrp Completion Routine, fGoingToD0 =%d\n", fGoingToD0));
                    IoSetCompletionRoutine(Irp,
                           FlashWr_PowerIrp_Complete,
						   // ɂ̃ReLXgƂĊ[`FDOʂ܂B
						   // ̓VXeɂă[`ɒʂꂽDriverObjectfoCX
						   // IuWFNg(PDO)łA@\foCXIuWFNg(FDO)ł͂ȂłB
                           DeviceObject,
                           TRUE,            // ȂĂ
                           TRUE,            // G[ȂĂ
                           TRUE);           // IRP̃LZɂĂ
                }

                PoStartNextPowerIrp(Irp);
                ntStatus = PoCallDriver(deviceExtension->TopOfStackDeviceObject,
                                        Irp);

                if ( !fGoingToD0 ) // [`Z܂
                    FlashWr_DecrementIoCount(DeviceObject);

                FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() Exit IRP_MN_SET_POWER\n"));
                break;
            } /* case irpStack->Parameters.Power.Type */

        }
        break; /* IRP_MN_SET_POWER */

    case IRP_MN_QUERY_POWER:
		//
		// p[|V[}l[W̓VXefoCXp[ԂύX邩ȂɊւ炸A
		// TăX[vɈڍs邱Ƃ肷邱IRP𑗂܂B
		//

        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() IRP_MN_QUERY_POWER\n"));

        // œȂƂ͂Ȃɂ܂BPDOɂ点邾łB
        IoCopyCurrentIrpStackLocationToNext(Irp);
        PoStartNextPowerIrp(Irp);
        ntStatus = PoCallDriver(deviceExtension->TopOfStackDeviceObject,
                                Irp);


        FlashWr_DecrementIoCount(DeviceObject);

        break; /* IRP_MN_QUERY_POWER */

    default:

        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_ProcessPowerIrp() UNKNOWN POWER MESSAGE (%x)\n", irpStack->MinorFunction));

        //
        // ׂ̑̂Ă̏Ȃp[bZ[WPDOɑ܂
        //

        IoCopyCurrentIrpStackLocationToNext(Irp);
        PoStartNextPowerIrp(Irp);
        ntStatus = PoCallDriver(deviceExtension->TopOfStackDeviceObject, Irp);

        FlashWr_DecrementIoCount(DeviceObject);

    } /* irpStack->MinorFunction */

    FLASHWR_KdPrint( DBGLVL_MEDIUM,  ( "Exit FlashWr_ProcessPowerIrp()  ntStatus = 0x%x\n", ntStatus ) );
    return ntStatus;
}


/*++
	́ÃfoCXłfoCXp[ԂɂȂƂɁASystemPowerState^Cv
	IRP_MN_SET_POWER󂯎ɉFlashWr_ProcessPowerIrp()ōPoRequestPowerIrp()̌Ăяo
	ŃZbg銮[`łB
	̏ꍇAIRP_MN_SET_POWER IRPւ̃|C^FDÕfoCXGNXeV̒(deviceExtension->PowerIrp)
	ɕۑÂƌĂяo̓foCXKȃp[ԂɂPoRequestPowerIrp()𐶐AĂ
	[`͊[`ƂăZbg܂B

	FlashWr͖IOJEgZÃhCoɕۑꂽIRP_MN_SET_POWERʂ܂B

:

    DeviceObject - NXfoCX̃foCXIuWFNgւ̃|C^
		        ReLXg̎g̃foCXIuWFNgłB

    Context - hCo[̒`ReLXgB̏ꍇAg̋@\foCXIuWFNg(FDO)

Ԃl:

    ֐l͍Ō̏̃Xe[^XłB

--*/
NTSTATUS
FlashWr_PoRequestCompletion(
    IN PDEVICE_OBJECT       DeviceObject,
    IN UCHAR                MinorFunction,
    IN POWER_STATE          PowerState,
    IN PVOID                Context,
    IN PIO_STATUS_BLOCK     IoStatus
    )
{
    PIRP irp;
    PDEVICE_EXTENSION deviceExtension;
    PDEVICE_OBJECT deviceObject = Context;
    NTSTATUS ntStatus;

    deviceExtension = deviceObject->DeviceExtension;

	// hCo[̃[`̊[`ƂPowerIRP̃NGXg邱Ƃ肵
	// ƂAFlashWr_ProcessPowerIrp()̂Ƃ̏ŃZ[uIRP擾܂B
    irp = deviceExtension->PowerIrp;

	// hCo[̊p[NGXgPDOɂZbgꂽXe[^XԂ܂
    ntStatus = IoStatus->Status;

    FLASHWR_KdPrint( DBGLVL_HIGH,("Enter FlashWr_PoRequestCompletion()\n"));

    // ŐPowerIRP̏̓rɂĂ͂Ȃ
    FLASHWR_ASSERT( !deviceExtension->SelfPowerIrp );

    // X^bN̒̎̃hCoɒʂȂ΂ȂȂ
    IoCopyCurrentIrpStackLocationToNext(irp);

	// PoStartNextPowerIrp()̌Ăяo̓hCoOPowerIRPƁA邢͎
	// PowerIRP̏sƂ̂ł
	// AePowerIRPŌĂ΂ȂĂ͂܂BPowerIRP͈ʂɂ̓foCX̂Ƃ
	// ჌x̃hCoɂĈx͊Ƃ͌ĂAPoStartNextPowerIrp͊eX^bN
	// ʒuŌĂ΂Ȃ΂ȂȂBhCo݂͌IRPX^bNʒũ݂hCoĂ
	// ԂPoStartNextPowerIrpĂяoȂ΂ȂȂB䂦Ã[`IoCompleteRequest,
	// IoSkipCurrentStackLocation,  PoCallDriveȓOɌĂ΂Ȃ΂ȂȂB

    PoStartNextPowerIrp(irp);

	// PoCallDriverIoCallDriver̕ςPDOPowerIRPʂ̂Ɏg܂BPowerIRP჌x
	// hCoʉ߂ƂAĂяõ͎X^bNʒuIRPRs[邽߂
	// IoSkipCurrentIrpStackLocation  IoCopyCurrentIrpStackLocationToNext gȂ΂ȂȂ
	// ܂BꂩAPoCallDriverĂяo܂B
	// IRP[`Zbg邱ƗvȂIoCopyCurrentIrpStackLocationToNext
	// A邢͊[`KvłȂIoSkipCurrentStackLocationgƁB

    PoCallDriver(deviceExtension->TopOfStackDeviceObject,
                 irp);

    FlashWr_DecrementIoCount(deviceObject);

    FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_PoRequestCompletion() Exit IRP_MN_SET_POWER\n"));

    deviceExtension->PowerIrp = NULL;

    return ntStatus;
}


/*++

	̃[`'DevicePowerState'^CvIRP_MN_SET_POWERFlashWr_ProcessPowerIrp()ɂ
	󂯎ꂽƂɌĂяo܂B
	̃[`肷͎̂̂ƂłB

	PjNGXgtp[iPowerDeviceD0jB
	Qjłɂ̏ԂɂȂB

	Ăяo͂̂Ƃ[`ƂăZbg邱̃[`PoRequestPowerIrp()ɂ܂B

:

    DeviceObject - NXfoCX̃foCXIuWFNg

    Irp - IRP

    Context - hCo[̒`ReLXg

Ԃl:

    ֐l͍Ō̏̃Xe[^XłB

--*/
NTSTATUS
FlashWr_PowerIrp_Complete(
    IN PDEVICE_OBJECT NullDeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT deviceObject;
    PIO_STACK_LOCATION irpStack;
    PDEVICE_EXTENSION deviceExtension;

    FLASHWR_KdPrint( DBGLVL_HIGH,("enter FlashWr_PowerIrp_Complete\n"));

    deviceObject = (PDEVICE_OBJECT) Context;

    deviceExtension = (PDEVICE_EXTENSION) deviceObject->DeviceExtension;

    // ʂ̃hCo[ԂĂÃX^bNɂ}[NB
    if (Irp->PendingReturned) {
        IoMarkIrpPending(Irp);
    }

    irpStack = IoGetCurrentIrpStackLocation (Irp);

    // foCXPowerUpD0NGXgAT[gł܂
    // Ƃ͍̂ŏ̏ꏊŃhCo[`Zbg郊NGXg̃^CvłB
    FLASHWR_ASSERT(irpStack->MajorFunction == IRP_MJ_POWER);
    FLASHWR_ASSERT(irpStack->MinorFunction == IRP_MN_SET_POWER);
    FLASHWR_ASSERT(irpStack->Parameters.Power.Type==DevicePowerState);
    FLASHWR_ASSERT(irpStack->Parameters.Power.State.DeviceState==PowerDeviceD0);

    // Ńp[AbvɕKvȂƂʂ̃hCoɂ邱Ƃ킩Ă܂B
    // foCXGNXeVɉăZbgł܂B
    deviceExtension->CurrentDevicePowerState = PowerDeviceD0;

    Irp->IoStatus.Status = ntStatus;

    FlashWr_DecrementIoCount(deviceObject);

    FLASHWR_KdPrint( DBGLVL_MEDIUM,("exit FlashWr_PowerIrp_Complete Exit IRP_MN_SET_POWER D0 complete\n"));
    return ntStatus;
}


/*++
		KvɂȂFlashWr_PnPAddDevice()Ńp[_E邽߂ɌĂяo܂
		iႦ΃pCvۂɊJ܂ŁjB
		ŏ̃pCvJOFlashWr_Create()ŃfoCXD0Ƀp[Abv邽߂ɌĂяo܂B
		ꂪŌ̃pCvȂ΁AFlashWr_Close()ŃfoCXp[_E邽߂ɌĂяo܂B

:
    DeviceObject - foCXIuWFNg̃|C^
    fSuspend - TRUEȂ΃TXyhAFALSEȂ΃ANeBuɂB

Ԃl:
	sȂSUCCESSԂB
	s΁Al͍Ō̏̃Xe[^XƂȂB
--*/
NTSTATUS
FlashWr_SelfSuspendOrActivate(
    IN PDEVICE_OBJECT DeviceObject,
    IN BOOLEAN fSuspend
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;

    POWER_STATE PowerState;
    PDEVICE_EXTENSION deviceExtension;


    deviceExtension = DeviceObject->DeviceExtension;
    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Enter FlashWr_SelfSuspendOrActivate(),fSuspend = %d\n", fSuspend));


	// ȉ̒ʂȂA󂯓邱Ƃ͂ł܂
    //  1) foCX폜Ă 
    //  2) ăX^[gȂ
    //  3) ~Ă
    //  4) [uNGXgɂȂĂ
    //  5) Stop DeviceɂȂĂ
    if ( !FlashWr_CanAcceptIoRequests( DeviceObject ) ) {
        ntStatus = STATUS_DELETE_PENDING;
        
		FLASHWR_KdPrint( DBGLVL_MEDIUM,("ABORTING FlashWr_SelfSuspendOrActivate()\n"));
        return ntStatus;
    }
  

    // VXefoCXPnP IRPł΂Ȃɂ܂B
    if ( NULL != deviceExtension->PowerIrp ) {
        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Exit FlashWr_SelfSuspendOrActivate(),refusing on pending deviceExtension->PowerIrp 0x%x\n", deviceExtension->PowerIrp));
        return ntStatus;
    }

    // ŐfoCXPnP IRPɂȂĂ΁AȂɂ܂B
    if ( deviceExtension->SelfPowerIrp ) {
        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Exit FlashWr_SelfSuspendOrActivate(),refusing on pending deviceExtension->SelfPowerIrp\n" ));
        return ntStatus;
    }

    // pCvJĂATXyhs܂B
    if ( fSuspend && ( 0 != deviceExtension->OpenPipeCount ) ) {
        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Exit FlashWr_SelfSuspendOrActivate(),refusing to self-suspend on OpenPipeCount %d\n", deviceExtension->OpenPipeCount));
        return ntStatus;
    }

    // pCvSJĂȂΎNs܂B
    if ( !fSuspend && ( 0 == deviceExtension->OpenPipeCount ) ) {
        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Exit FlashWr_SelfSuspendOrActivate(),refusing to self-activate, no pipes open\n"));
        return ntStatus;
    }

    // CurrentControlSet\Services\FlashWr\Parameters\PowerDownLevelWXg0APowerDeviceD0(1)A
    // 邢͋U̍lZbgĂ΁AȂB
    if ( ( deviceExtension->PowerDownLevel == PowerDeviceD0 ) || 
         ( deviceExtension->PowerDownLevel == PowerDeviceUnspecified)  ||
         ( deviceExtension->PowerDownLevel >= PowerDeviceMaximum ) ) {
        FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Exit FlashWr_SelfSuspendOrActivate(), refusing on deviceExtension->PowerDownLevel == %d\n", deviceExtension->PowerDownLevel));
        return ntStatus;
    }

    if ( fSuspend )
        PowerState.DeviceState = deviceExtension->PowerDownLevel;
    else
        PowerState.DeviceState = PowerDeviceD0;  //ƃp[AbvĂB炭A܂ɂIOs

    ntStatus = FlashWr_SelfRequestPowerIrp( DeviceObject, PowerState );

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_SelfSuspendOrActivate() status 0x%x on setting dev state %s\n", ntStatus, FLASHWR_StringForDevState(PowerState.DeviceState ) ));

    return ntStatus;

}


/*++
	̃[`͎ۂɃp[Ԃp[Abv^_EVXeNGXg𐶐邽߂
	FlashWr_SelfSuspendOrActivate()ɂĂяo܂B
	łɃp[Ԃɂ邩ǂAŏɂ݂ă`FbN܂B
	āAȂAɂȏ̏邱ƂȂԂ܂B

:

    DeviceObject - foCXIuWFNgւ̃|C^
    PowerState - NGXgꂽp[ԁiႦ PowerDeviceD0j

Ԃl:
    ֐l͍Ō̏̃Xe[^XԂB

--*/
NTSTATUS
FlashWr_SelfRequestPowerIrp(
    IN PDEVICE_OBJECT DeviceObject,
    IN POWER_STATE PowerState
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    PIRP pIrp = NULL;

    deviceExtension =  DeviceObject->DeviceExtension;

    // ͊[`̂ȂŃZbgĂȂ΂ȂȂ
    FLASHWR_ASSERT( !deviceExtension->SelfPowerIrp );

    if (  deviceExtension->CurrentDevicePowerState ==  PowerState.DeviceState )
        return STATUS_SUCCESS;  // nothing to do

    FLASHWR_KdPrint( DBGLVL_HIGH,("Enter FlashWr_SelfRequestPowerIrp() will request power irp to state %s\n",
        FLASHWR_StringForDevState( PowerState.DeviceState )));

    FlashWr_IncrementIoCount(DeviceObject);

	// ȐPowerIRP̏tO𗧂Ă
    deviceExtension->SelfPowerIrp = TRUE;

	// IIRPNGXgB
    ntStatus = PoRequestPowerIrp(deviceExtension->PhysicalDeviceObject, 
                         IRP_MN_SET_POWER,
                         PowerState,
                         FlashWr_PoSelfRequestCompletion,
                         DeviceObject,
                         NULL);


    if  ( ntStatus == STATUS_PENDING ) { 
        // Xe[^X̓^[R[hKvłB

        // p[AbvĂrȂ犮҂Kv܂
        if ( (ULONG) PowerState.DeviceState < deviceExtension->PowerDownLevel ) {

            NTSTATUS waitStatus;

            waitStatus = KeWaitForSingleObject(
                           &deviceExtension->SelfRequestedPowerIrpEvent,
                           Suspended,
                           KernelMode,
                           FALSE,
                           NULL);

        }

        ntStatus = STATUS_SUCCESS;

        deviceExtension->SelfPowerIrp = FALSE;

        FLASHWR_KdPrint( DBGLVL_HIGH, ("FlashWr_SelfRequestPowerIrp() SUCCESS\n    IRP 0x%x to state %s\n",
            pIrp, FLASHWR_StringForDevState(PowerState.DeviceState) ));


    }
    else {
    	// ^[Xe[^XSTATUS_PENDINGł͂܂B
    	// ̏ꍇAɃG[ƍlȂ΂܂B
    	// Ȃ킿ASTATUS_SUCCESS擾łA邢͂̌Ăяo瑼̃G[Ȃ̕Ԃl
    	// 擾ł\͂ȂƂƂłB
        FLASHWR_KdPrint( DBGLVL_HIGH, ("FlashWr_SelfRequestPowerIrp() to state %s FAILED, status = 0x%x\n",
            FLASHWR_StringForDevState( PowerState.DeviceState ),ntStatus));
    }

    return ntStatus;
}



/*++
	̃[`FlashWr_SelfSuspendOrActivate()ւ̌Ăяoɂ萶ꂽȃIWiPowerIRP
	hCoƂɌĂ΂܂B
	hCóAŌ̃pCvN[YƂɂ͂łp[_EAŏ̃pCvJƂ
	p[Abv܂B
	p[Abvł́AIRPIƂFDÕGNXXeṼCxgVOiԂɂA
	ăp[NGXg͓IĂяoƂĈ邱Ƃł悤ɂȂ܂B
	Ⴆ΁Aŏ̃pCvJ܂ɃfoCXp[AbvƂmKv܂B
	p[_Eł̓CxgZbg܂B̓p[_E҂Ăяo݂͑ȂłB

:
    DeviceObject - NXfoCX̃foCXIuWFNg( foCXIuWFNg )
    Context - hCo̒`ReLXgB̏ꍇł͋@\foCXIuWFNg( FDO )

Ԃl:
    ֐l͍Ō̏̃Xe[^XłB

--*/
NTSTATUS
FlashWr_PoSelfRequestCompletion(
    IN PDEVICE_OBJECT       DeviceObject,
    IN UCHAR                MinorFunction,
    IN POWER_STATE          PowerState,
    IN PVOID                Context,
    IN PIO_STATUS_BLOCK     IoStatus
    )
{
    PDEVICE_OBJECT deviceObject = Context;
    PDEVICE_EXTENSION deviceExtension = deviceObject->DeviceExtension;
    NTSTATUS ntStatus = IoStatus->Status;

    // VXe̐PowerIRPłĂ͂ȂȂ
    FLASHWR_ASSERT( NULL == deviceExtension->PowerIrp );

    // p[AbvĂŒȂCxgZbgKv͂܂
    // p[_E̊҂Ăяo݂͑Ȃ
    if ( (ULONG) PowerState.DeviceState < deviceExtension->PowerDownLevel ) {

        // ȃNGXgPowerIRP̊CxgVOiԂɂ܂
        //  Ăяo͊҂܂
        KeSetEvent(&deviceExtension->SelfRequestedPowerIrpEvent, 1, FALSE);
    }

    FlashWr_DecrementIoCount(deviceObject);

    FLASHWR_KdPrintCond( DBGLVL_HIGH, !NT_SUCCESS(ntStatus),("Exit FlashWr_PoSelfRequestCompletion() FAILED, ntStatus = 0x%x\n", ntStatus ));
   
    return ntStatus;
}


/*++
	̃[`'DevicePowerState'^CvIRM_MN_SET_POWERFlashWr_ProcessPowerIrp()ɂ
	󂯎ƂĂяoB

:
    DeviceObject - NXfoCX̃foCXIuWFNg
    DeviceState - foCXɃZbgfoCXL̃p[

Ԃl:
    DeviceState D0(tp[j̃NGXgł͊[`ZbgAŏI点Ȃ΂ȂȂ
    ĂяoVOiԂɂ邽߂TRUEԂ܂B
--*/
BOOLEAN
FlashWr_SetDevicePowerState(
    IN PDEVICE_OBJECT DeviceObject,
    IN DEVICE_POWER_STATE DeviceState
    )
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    BOOLEAN fRes = FALSE;

    deviceExtension = (PDEVICE_EXTENSION) DeviceObject->DeviceExtension;

    switch (DeviceState) {
    case PowerDeviceD3:

		//
		// foCXOFFɈڍs܂B
		// 邱ƁF
		//   ŏԂۑ邽߂̕KvȃfoCXŗL̃R[hǉ܂B
		//   (̃Tvł͕Kv܂B)
        //

        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_SetDevicePowerState() PowerDeviceD3 (OFF)\n"));

        deviceExtension->CurrentDevicePowerState = DeviceState;
        break;

    case PowerDeviceD1:
    case PowerDeviceD2:
        //
        // p[D1,D2USBTXyhɖ|󂵂܂

        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_SetDevicePowerState()  %s\n",
            FLASHWR_StringForDevState(DeviceState) ));

        deviceExtension->CurrentDevicePowerState = DeviceState;
        break;

    case PowerDeviceD0:


        FLASHWR_KdPrint( DBGLVL_MEDIUM,("FlashWr_SetDevicePowerState() PowerDeviceD0 (ON)\n"));

		// [`̒ŁAx~I点Kv܂B
		//   D0ɈڍsA[`ZbgKvĂяoVOiԂɂ܂B
        fRes = TRUE;

        // ĂяoPDOɐi݂܂B
        break;

    default:

        FLASHWR_KdPrint( DBGLVL_MEDIUM,(" Bogus DeviceState = %x\n", DeviceState));
    }

    return fRes;
}



/*++
	̃[`PDO CAPS擾邽߂PDOɂ̃hCo[
	IRP𐶐܂B
	VXep[ԂIRP_MJ_SET_POWER IRP󂯎foCXp[Ԃ
	}bv邱ƂwԂ̂ƂdvłB

	͏ICxg̃Zbg邽߂IRP[`҂Ăяo
	ubLO܂B

:
    DeviceObject - USBRg[̕foCXIuWFNg(PDO)

Ԃl:
    IoCallriverĂяoNTSTATUSl

--*/
NTSTATUS
FlashWr_QueryCapabilities(
    IN PDEVICE_OBJECT PdoDeviceObject,
    IN PDEVICE_CAPABILITIES DeviceCapabilities
    )
{
    PIO_STACK_LOCATION nextStack;
    PIRP irp;
    NTSTATUS ntStatus;
    KEVENT event;


	// DDK`̃fobOp}NłB̃}NAPC_LEVELȏŃvO
	// y[WO\R[h𑖂点ĂȂƂɃAT[g܂B
    PAGED_CODE();


    // PDOɓ₢킹NGXg𐶐IRP\z܂B
    irp = IoAllocateIrp(PdoDeviceObject->StackSize, FALSE);

    if (!irp) {
        return STATUS_INSUFFICIENT_RESOURCES;
    }


    // IoGetNextIrpStackLocation͍ʃx̃hCõANZXAIRP̒̎ɒႢhCo
    // I/OX^bNʒuɗ^܂BāAĂяo͒ʂ̃hCoZbgAbvł܂B
    nextStack = IoGetNextIrpStackLocation(irp);
    FLASHWR_ASSERT(nextStack != NULL);
    nextStack->MajorFunction= IRP_MJ_PNP;
    nextStack->MinorFunction= IRP_MN_QUERY_CAPABILITIES;

    // [`ĂяoꂽƂɋĂCxg܂B
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // [`Zbg܂BāA͎̒ʂ̃hCoIRPIƂACxg
    // VOiԂɂ܂B
    IoSetCompletionRoutine(irp,
                           FlashWr_IrpCompletionRoutine,
                           &event,  // [`ɃReLXgƂĒʂ
                           TRUE,    // ɌĂяo
                           TRUE,    // G[ɌĂяo
                           TRUE);   // IRP̃LZɌĂяo


    // g̃|C^DEVICE_CAPABILITIESɃZbg܂
    nextStack->Parameters.DeviceCapabilities.Capabilities = DeviceCapabilities;

    ntStatus = IoCallDriver(PdoDeviceObject,
                            irp);

    FLASHWR_KdPrint( DBGLVL_MEDIUM,(" FlashWr_QueryCapabilities() ntStatus from IoCallDriver to PCI = 0x%x\n", ntStatus));

    if (ntStatus == STATUS_PENDING) {
       // IRP̊҂܂

       KeWaitForSingleObject(
            &event,
            Suspended,
            KernelMode,
            FALSE,
            NULL);
    }

    // sȂoO(^^;
    FLASHWR_KdPrintCond( DBGLVL_DEFAULT,(!NT_SUCCESS(ntStatus)), ("FlashWr_QueryCapabilities() failed\n"));

    IoFreeIrp(irp);

    return ntStatus;
}







